Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs	(revision 16899)
@@ -91,5 +91,5 @@
     #region old storable format
     // remove with HL 3.4
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "SerializedTree")]
     // to prevent storing the references to data caches in nodes
     // seemingly, it is bad (performance-wise) to persist tuples (tuples are used as keys in a dictionary)
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NearestNeighbour/NearestNeighbourModel.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NearestNeighbour/NearestNeighbourModel.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NearestNeighbour/NearestNeighbourModel.cs	(revision 16899)
@@ -294,5 +294,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this nearest neighbour model. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkEnsembleModel.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkEnsembleModel.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkEnsembleModel.cs	(revision 16899)
@@ -144,5 +144,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this neural network ensemble. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
@@ -153,5 +153,5 @@
       return new NeuralNetworkEnsembleClassificationSolution(this, new ClassificationEnsembleProblemData(problemData));
     }
-   
+
     #region persistence
     [Storable]
@@ -183,5 +183,5 @@
       }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronEnsembleDfdnet")]
     private double[] MultiLayerPerceptronEnsembleDfdnet {
       set {
@@ -197,9 +197,9 @@
       }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronEnsembleNeurons")]
     private double[] MultiLayerPerceptronEnsembleNeurons {
       set { mlpEnsemble.innerobj.network.neurons = value; }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronEnsembleSerializedMlp")]
     private double[] MultiLayerPerceptronEnsembleSerializedMlp {
       set {
@@ -207,5 +207,5 @@
       }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronStuctinfo")]
     private int[] MultiLayerPerceptronStuctinfo {
       set {
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkModel.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkModel.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkModel.cs	(revision 16899)
@@ -147,5 +147,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this neural network. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/RandomForest/RandomForestModel.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/RandomForest/RandomForestModel.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/RandomForest/RandomForestModel.cs	(revision 16899)
@@ -300,5 +300,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this random forest. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineModel.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineModel.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineModel.cs	(revision 16899)
@@ -143,5 +143,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this SVM. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMAlgorithm.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMAlgorithm.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMAlgorithm.cs	(revision 16899)
@@ -28,5 +28,4 @@
 using HeuristicLab.Random;
 using HeuristicLab.Selection;
-using System;
 using System.Collections.Generic;
 using System.IO;
@@ -40,11 +39,9 @@
   [StorableType("AD23B21F-089A-4C6C-AD2E-1B01E7939CF5")]
   public class EMMAlgorithm : EvolvmentModelsOfModelsAlgorithmBase {
-    public EMMMapTreeModel Map { get; private set; }
-
     public EMMAlgorithm() : base() { }
     protected EMMAlgorithm(EMMAlgorithm original, Cloner cloner) : base(original, cloner) {
-      if (original.Map != null) {
-        Map = cloner.Clone(original.Map);
-      }
+      //if (original.Map != null) {
+      //  Map = cloner.Clone(original.Map);
+      //}
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -58,64 +55,25 @@
       InfixExpressionParser parser = new InfixExpressionParser();
       var trees = File.ReadAllLines(InputFileParameter.Value.Value).Select(parser.Parse);
-      // this.Problem.SymbolicExpressionTreeGrammar;
-      /*   Problem.ProblemData.Dataset.ColumnNames.Take(2).ToList();
-         trees.First().Root.Grammar.ContainsSymbol((IVariable)a).
-           = this.Problem.SymbolicExpressionTreeGrammar;*/
-      int neghboorNumber = 10;
-      switch (MapCreationType.Value) { // Configure Map type and it's parameters: IslandMap, FullMap and Percent, Number
-        case "IslandMap": break;
-        case "FullMap":
-          ClusterNumbersParameter.Value.Value = trees.Count();
-          switch (NegbourType.Value) {
-            case "Percent": neghboorNumber = Convert.ToInt32((Convert.ToDouble(ClusterNumbersParameter.Value.Value)) * (Convert.ToDouble(NegbourNumber.Value)) / 100.0); break;
-            case "Number": neghboorNumber = NegbourNumber.Value; break;
-            default: neghboorNumber = NegbourNumber.Value; break;
-          }
-          break;
-        default: MapCreationType.Value = "IslandMap"; break;
-      }
-      switch (AlgorithmImplemetationType.Value) { //Configure type of algorithm application
-        case "OnlyMapCreation": // for case when we want only create map, and do  not want made somting also. OnlyMapCreation, CrateMapAndGo, ReadMapAndGo
-          Map = new EMMMapTreeModel(RandomParameter.Value, trees, ClusterNumbersParameter.Value.Value, neghboorNumber);
-          ClusterNumbersParameter.Value.Value = Map.K;
-          File.WriteAllLines("Map.txt", Map.MapToString());
-          File.WriteAllLines("MapToSee.txt", Map.MapToSee());
-          globalScope = new Scope("Global Scope");
-          executionContext = new ExecutionContext(null, this, globalScope);
-          break;
-        case "ReadMapAndGo": // for case when we want read existed map and work with it;
-          Map = new EMMMapTreeModel(RandomParameter.Value, trees);
-          ClusterNumbersParameter.Value.Value = Map.K;
-          if (previousExecutionState != ExecutionState.Paused) {
-            InitializeAlgorithm(cancellationToken);
-          }
+      if (AlgorithmImplemetationType.Value == "Read") {
+        Map.MapRead(RandomParameter.Value, trees, "Map.txt");
+      } else {
+        Map.MapCreationPrepare(RandomParameter.Value, trees, ClusterNumbersParameter.Value.Value);
+        Map.CreateMap(RandomParameter.Value, ClusterNumbersParameter.Value.Value);
+       // Map.WriteMapToTxtFile(RandomParameter.Value);
+      }
+
+      ClusterNumbersShowParameter.Value.Value = Map.K;
+
+      if (AlgorithmImplemetationType.Value == "OnlyMap") {
+        globalScope = new Scope("Global Scope");
+        executionContext = new ExecutionContext(null, this, globalScope);
+      } else {
+        if (previousExecutionState != ExecutionState.Paused) {
+          InitializeAlgorithm(cancellationToken);
+        }
+        if (!globalScope.Variables.ContainsKey("TreeModelMap"))
           globalScope.Variables.Add(new Variable("TreeModelMap", Map));
-          EMMAlgorithmRun(cancellationToken);
-          break;
-        case "CreateMapAndGo":
-          Map = new EMMMapTreeModel(RandomParameter.Value, trees, ClusterNumbersParameter.Value.Value, neghboorNumber);
-          ClusterNumbersParameter.Value.Value = Map.K;
-          if (previousExecutionState != ExecutionState.Paused) {
-            InitializeAlgorithm(cancellationToken);
-          }
-          globalScope.Variables.Add(new Variable("TreeModelMap", Map));
-          File.WriteAllLines("Map.txt", Map.MapToString());
-          File.WriteAllLines("MapToSee.txt", Map.MapToSee());
-          EMMAlgorithmRun(cancellationToken);
-          break;
-        default: //for case of usial from zero step starting
-          AlgorithmImplemetationType.Value = "CreateMapAndGo";
-          Map = new EMMMapTreeModel(RandomParameter.Value, trees, ClusterNumbersParameter.Value.Value, neghboorNumber);
-          ClusterNumbersParameter.Value.Value = Map.K;
-          File.WriteAllLines("Map.txt", Map.MapToString());
-          File.WriteAllLines("MapToSee.txt", Map.MapToSee());
-          if (previousExecutionState != ExecutionState.Paused) {
-            InitializeAlgorithm(cancellationToken);
-          }
-          globalScope.Variables.Add(new Variable("TreeModelMap", Map));
-          EMMAlgorithmRun(cancellationToken);
-          break;
-      }
-
+        EMMAlgorithmRun(cancellationToken);
+      }
     }
     private void EMMAlgorithmRun(CancellationToken cancellationToken) {
@@ -227,13 +185,13 @@
 
       // initialize data structures for map clustering
-      var models = new ItemList<ISymbolicExpressionTree>(Map.ModelSet);
-      var map = new ItemList<ItemList<IntValue>>();
-      foreach (var list in Map.Map) {
-        map.Add(new ItemList<IntValue>(list.Select(x => new IntValue(x))));
-      }
-      var clusterNumber = new ItemList<IntValue>(Map.ClusterNumber.Select(x => new IntValue(x)));
-      globalScope.Variables.Add(new Core.Variable("Models", models));
-      globalScope.Variables.Add(new Core.Variable("Map", map));
-      globalScope.Variables.Add(new Core.Variable("ClusterNumber", clusterNumber));
+      //var models = new ItemList<ISymbolicExpressionTree>(Map.ModelSet);
+      //var map = new ItemList<ItemList<IntValue>>();
+      //foreach (var list in Map.Map) {
+      //  map.Add(new ItemList<IntValue>(list.Select(x => new IntValue(x))));
+      //}
+      //var clusterNumber = new ItemList<IntValue>(Map.ClusterNumber.Select(x => new IntValue(x)));
+      //globalScope.Variables.Add(new Variable("Models", models));
+      //globalScope.Variables.Add(new Variable("Map", map));
+      //globalScope.Variables.Add(new Variable("ClusterNumber", clusterNumber));
 
       EvaluatedSolutions = populationSize;
@@ -274,6 +232,50 @@
       }
     }
+    private void LocalDecent(ISymbolicDataAnalysisSingleObjectiveProblem problem, CancellationToken cancellationToken, IScope childScope) {
+      int maxStepNumber = 100;
+      var creator = Problem.SolutionCreator;
+      var name = ((ISymbolicExpressionTreeCreator)creator).SymbolicExpressionTreeParameter.ActualName;
+      var tree = (ISymbolicExpressionTree)childScope.Variables[name].Value;
+      var evaluator = problem.Evaluator;
+      var oldTree = tree.Clone();
+      ExecuteOperation(executionContext, cancellationToken, executionContext.CreateChildOperation(evaluator, childScope));
+      var rand = RandomParameter.Value;
+      if (SetSeedRandomly) Seed = RandomSeedGenerator.GetSeed();
+      rand.Reset(Seed);
+      while (maxStepNumber > 0) {
+        maxStepNumber = TreeIterator(tree.Root, rand, cancellationToken, childScope, maxStepNumber);
+      }
+    }
+    int TreeIterator(ISymbolicExpressionTreeNode a, IRandom rand, CancellationToken cancellationToken, IScope childScope, int maxStepNumber) {
+      if (a is TreeModelTreeNode modelNode) {
+        ModelChange(modelNode, rand, cancellationToken, childScope);
+        maxStepNumber--;
+      }
+      if (a.Subtrees != null) {
+        for (int i = 0; i < (a.Subtrees.Count()); i++) {
+          TreeIterator(a.Subtrees.ToList()[i], rand, cancellationToken, childScope, maxStepNumber);
+        }
+      }
+      return maxStepNumber;
+    }
+    void ModelChange(TreeModelTreeNode a, IRandom rand, CancellationToken cancellationToken, IScope childScope) {
+      int treeNumber = a.TreeNumber;
+      var oldSubTree = (ISymbolicExpressionTree)a.Tree.Clone();
+      double oldQuality = ((DoubleValue)childScope.Variables["Quality"].Value).Value;
+      int cluster = Map.ClusterNumber[treeNumber];
+      int newTreeNumber = rand.Next(Map.Map[cluster].Count);
+      a.Tree = (ISymbolicExpressionTree)Map.ModelSet[newTreeNumber].Clone();
+      a.Tree.Root.ShakeLocalParameters(rand, 1);
+      var evaluator = Problem.Evaluator;
+      ExecuteOperation(executionContext, cancellationToken, executionContext.CreateChildOperation(evaluator, childScope));
+      double currentQuality = ((DoubleValue)childScope.Variables["Quality"].Value).Value;
+      if (oldQuality > currentQuality) {
+        a.Tree = (ISymbolicExpressionTree)oldSubTree.Clone();
+        ((DoubleValue)childScope.Variables["Quality"].Value).Value = oldQuality;
+      }
+    }
   }
 
+
 }
 
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMBaseAlgorithm.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMBaseAlgorithm.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMBaseAlgorithm.cs	(revision 16899)
@@ -26,4 +26,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -55,4 +56,7 @@
     [Storable]
     protected ExecutionState previousExecutionState;
+
+    [Storable]
+    protected ExecutionState currentExecutionState;
     #endregion
 
@@ -72,6 +76,7 @@
     private const string InputFileParameterName = "InputFile";
     private const string ClusterNumbersParameterName = "ClusterNumbers";
+    private const string ClusterNumbersShowParameterName = "ClusterNumbersShow";
     private const string AlgorithmImplementationTypeParameterName = "AlgorithmImplemetationType";
-    private const string MapCreationTypeParameterName = "MapCreationType";
+    private const string MapParameterName = "Map";
     private const string NegbourTypeParameterName = "NegbourType";
     private const string NegbourNumberParameterName = "NegbourNumber";
@@ -85,9 +90,12 @@
       get { return (IValueParameter<IntValue>)Parameters[ClusterNumbersParameterName]; }
     }
-    public IFixedValueParameter<StringValue> AlgorithmImplementationTypeParameter {
-      get { return (IFixedValueParameter<StringValue>)Parameters[AlgorithmImplementationTypeParameterName]; }
-    }
-    public IFixedValueParameter<StringValue> MapCreationTypeParameter {
-      get { return (IFixedValueParameter<StringValue>)Parameters[MapCreationTypeParameterName]; }
+    public IValueParameter<IntValue> ClusterNumbersShowParameter {
+      get { return (IValueParameter<IntValue>)Parameters[ClusterNumbersShowParameterName]; }
+    }
+    public IConstrainedValueParameter<StringValue> AlgorithmImplementationTypeParameter {
+      get { return (IConstrainedValueParameter<StringValue>)Parameters[AlgorithmImplementationTypeParameterName]; }
+    }
+    public IConstrainedValueParameter<EMMMapBase<ISymbolicExpressionTree>> MapParameter {
+      get { return (IConstrainedValueParameter<EMMMapBase<ISymbolicExpressionTree>>)Parameters[MapParameterName]; }
     }
     public IFixedValueParameter<StringValue> NegbourTypeParameter {
@@ -144,11 +152,15 @@
       set { ClusterNumbersParameter.Value = value; }
     }
+    public IntValue ClusterNumbersShow {
+      get { return ClusterNumbersShowParameter.Value; }
+      set { ClusterNumbersShowParameter.Value = value; }
+    }
     public StringValue AlgorithmImplemetationType {
       get { return AlgorithmImplementationTypeParameter.Value; }
       set { AlgorithmImplementationTypeParameter.Value.Value = value.Value; }
     }
-    public StringValue MapCreationType {
-      get { return MapCreationTypeParameter.Value; }
-      set { MapCreationTypeParameter.Value.Value = value.Value; }
+    public EMMMapBase<ISymbolicExpressionTree> Map {
+      get { return MapParameter.Value; }
+      set { MapParameter.Value = value; }
     }
     public StringValue NegbourType {
@@ -214,6 +226,6 @@
       Parameters.Add(new FixedValueParameter<IntValue>(SeedParameterName, "The random seed used to initialize the new pseudo random number generator.", new IntValue(0)));
       Parameters.Add(new FixedValueParameter<StringValue>(InputFileParameterName, "The file with set of models that will be.", new StringValue("input.txt")));
-      Parameters.Add(new FixedValueParameter<StringValue>(AlgorithmImplementationTypeParameterName, "The Type of possible algorith, implemetation, choose one: OnlyMapCreation, CreateMapAndGo, ReadMapAndGo.", new StringValue("CreateMapAndGo")));
-      Parameters.Add(new FixedValueParameter<StringValue>(MapCreationTypeParameterName, "The type of map crearion algorithm. Use one from: IslandMap, FullMap.", new StringValue("IslandMap")));
+      Parameters.Add(new ConstrainedValueParameter<StringValue>(AlgorithmImplementationTypeParameterName, "The Type of possible algorith, implemetation, choose one: OnlyMap, Full, Read."));
+      Parameters.Add(new ConstrainedValueParameter<EMMMapBase<ISymbolicExpressionTree>>(MapParameterName, "The type of map crearion algorithm. Use one from: IslandMap, NetworkMap."));
       Parameters.Add(new FixedValueParameter<IntValue>(NegbourNumberParameterName, "The parametr for FullMap type of map crearion algorithm. Use one from: 10, 20.", new IntValue(10)));
       Parameters.Add(new FixedValueParameter<StringValue>(NegbourTypeParameterName, "The parametr for FullMap type of map crearion algorithm. Use one from: Percent, Number.", new StringValue("Number")));
@@ -230,5 +242,6 @@
       Parameters.Add(new ValueParameter<IRandom>(RandomParameterName, new MersenneTwister()));
       Parameters.Add(new ValueParameter<IntValue>("Elites", "The numer of elite Solutions which are kept in each generation.", new IntValue(1)));
-      Parameters.Add(new ValueParameter<IntValue>(ClusterNumbersParameterName, "The number of clusters for model Map.", new IntValue(100)));
+      Parameters.Add(new ValueParameter<IntValue>(ClusterNumbersParameterName, "The number of clusters for model Map.", new IntValue(10)));
+      Parameters.Add(new ValueParameter<IntValue>(ClusterNumbersShowParameterName, "The number of clusters for model Map.", new IntValue(10)));
       foreach (ISelector selector in ApplicationManager.Manager.GetInstances<ISelector>().Where(x => !(x is IMultiObjectiveSelector)).OrderBy(x => x.Name))
         SelectorParameter.ValidValues.Add(selector);
@@ -238,5 +251,5 @@
 
       ProblemChanged += EvolvmentModelsOfModelsAlgorithmBase_ProblemChanged;
-
+      MapParameterUpdate();
     }
 
@@ -245,4 +258,30 @@
         Problem.SymbolicExpressionTreeInterpreter = new SymbolicDataAnalysisExpressionTreeBatchInterpreter();
         //Problem.SymbolicExpressionTreeGrammar = new EMMGrammar();
+      }
+    }
+    protected void MapParameterUpdate() {
+      int neghboorNumber = 10;
+
+      switch (NegbourType.Value) {
+        case "Percent": neghboorNumber = Convert.ToInt32((Convert.ToDouble(ClusterNumbersParameter.Value.Value)) * (Convert.ToDouble(NegbourNumber.Value)) / 100.0); break;
+        case "Number": neghboorNumber = NegbourNumber.Value; break;
+        default: neghboorNumber = NegbourNumber.Value; break;
+      }
+      var mapTypes = new EMMMapBase<ISymbolicExpressionTree>[]
+      {
+        new EMMIslandMap(),
+        new EMMNetworkMap(neghboorNumber)
+      };
+      foreach (var t in mapTypes) {
+        MapParameter.ValidValues.Add(t);
+      }
+      var algorithmType = new StringValue[]
+        {
+          new StringValue("Full"),
+          new StringValue("Read"),
+          new StringValue ("OnlyMap")
+        };
+      foreach (var t in algorithmType) {
+        AlgorithmImplementationTypeParameter.ValidValues.Add(t);
       }
     }
@@ -410,5 +449,6 @@
 
     protected override void OnExecutionStateChanged() {
-      previousExecutionState = ExecutionState;
+      previousExecutionState = currentExecutionState;
+      currentExecutionState = ExecutionState;
       base.OnExecutionStateChanged();
     }
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMBaseMap.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMBaseMap.cs	(revision 16899)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMBaseMap.cs	(revision 16899)
@@ -0,0 +1,191 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+
+namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
+  [StorableType("83CF9650-98FF-454B-9072-82EA4D39C752")]
+  public abstract class EMMMapBase<T> : Item where T : class {
+    [Storable]
+    public List<T> ModelSet { get; set; }
+    [Storable]
+    public List<int> ClusterNumber { get; set; }
+    [Storable]
+    public List<List<int>> Map { get; set; }
+    [Storable]
+    public double[,] Distances { get; set; }
+    [Storable]
+    public int K { get; protected set; }
+
+    protected void CalculateDistances() {
+      if (ModelSet is List<ISymbolicExpressionTree> set) {
+        Distances = SymbolicExpressionTreeHash.ComputeSimilarityMatrix(set, simplify: false, strict: true);
+      } else { /// for future work
+        for (int i = 0; i < ModelSet.Count - 1; i++) {
+          for (int j = 0; j <= i; j++) {
+            Distances[i, j] = 0;
+          }
+        }
+      }
+      for (int i = 0; i < ModelSet.Count - 1; i++) {
+        for (int j = i + 1; j < ModelSet.Count; j++) {
+          Distances[j, i] = Distances[i, j] = 1 - Distances[i, j];
+        }
+      }
+
+    }
+    public abstract void CreateMap(IRandom random, int k);
+    public abstract T NewModelForInizializtionNotTree(IRandom random, out int cluster, out int treeNumber);
+    public ISymbolicExpressionTree NewModelForInizializtion(IRandom random, out int cluster, out int treeNumber) {
+      treeNumber = random.Next(ModelSet.Count);
+      cluster = ClusterNumber[treeNumber];
+      if (ModelSet[treeNumber] is ISymbolicExpressionTree model)
+        return (ISymbolicExpressionTree)(model.Clone());
+      return new SymbolicExpressionTree();
+    }
+
+    [StorableConstructor]
+    protected EMMMapBase(StorableConstructorFlag _) : base(_) { }
+    protected EMMMapBase() : this(1) { }
+    public EMMMapBase(int k) {
+      K = k;
+      ClusterNumber = new List<int>();
+      Map = new List<List<int>>();
+    }
+    public EMMMapBase(EMMMapBase<T> original, Cloner cloner) {
+      if (original.ModelSet != null) {
+        if (original.ModelSet is List<ISymbolicExpressionTree> originalSet && ModelSet is List<ISymbolicExpressionTree> set)
+          set = originalSet.Select(cloner.Clone).ToList();
+        else ModelSet = original.ModelSet.ToList(); /// check this if you want to use it
+      }
+      if (original.ClusterNumber != null) {
+        ClusterNumber = original.ClusterNumber.ToList();
+      }
+      if (original.Map != null) {
+        Map = original.Map.Select(x => x.ToList()).ToList();
+      }
+      K = original.K;
+    }
+    //public EMMMapBase(IRandom random, IEnumerable<T> trees, int k) : this(k) {
+    //  // constructor that should be used in case of creation of a new map from the start point
+    //  ModelSet = trees.ToList();
+    //  CalculateDistances();
+    //  CreateMap(random, k);
+    //}
+    //public EMMMapBase(IRandom random, IEnumerable<T> trees, string fileName = "Map.txt") : this(1) {
+    //  // constructor that shoud be used in case of using of "old" map, that was previously created and now shoud be readed from file
+    //  ModelSet = trees.ToList();
+    //  MapFromFileRead(fileName);
+    //  K = Map.Count;
+    //  MapPreparation();
+    //}
+    public void MapCreationPrepare(IRandom random, IEnumerable<T> trees, int k) {
+      ModelSet = trees.ToList();
+      CalculateDistances();
+      CreateMap(random, k);
+    }
+    public void MapRead(IRandom random, IEnumerable<T> trees, string fileName = "Map.txt") {
+      ModelSet = trees.ToList();
+      MapFromFileRead(fileName);
+      K = Map.Count;
+      MapPreparation();
+      if (this is EMMNetworkMap one) { one.NeghboorNumber = Map[0].Count; }
+    }
+    public void WriteMapToTxtFile(IRandom random) {
+      string s = random.ToString();
+      string fileName = "Map";
+      fileName += s;
+      fileName += ".txt";
+      File.WriteAllLines(fileName, MapToString());
+      string fileName2 = "MapToSee";
+      fileName2 += s;
+      fileName2 += ".txt";
+      File.WriteAllLines(fileName, MapToSee());
+    }
+    public string[] MapToString() { // Function that preapre Map to printing in .txt File: create a set of strings for future reading by computer
+      string[] s;
+      s = new string[K];
+      for (int i = 0; i < K; i++) {
+        s[i] = "";
+        for (int j = 0; j < Map[i].Count; j++) {
+          s[i] += Map[i][j].ToString();
+          s[i] += " ";
+        }
+      }
+      return s;
+    }
+    public string[] MapToSee() { // Function that prepare Map to printing in .txt File: create a set of strings in human readable view
+      var fmt = new InfixExpressionFormatter();
+      string[] s;
+      s = new string[(ModelSet.Count) + 1];
+      s[0] = "ClusterNumber" + "," + "ModelNumber" + "," + "Model";
+      for (int i = 1; i < ((ModelSet.Count) + 1); i++) {
+        s[i] = ClusterNumber[i - 1].ToString() + "," + (i - 1).ToString() + ",";
+        if (ModelSet[i - 1] is ISymbolicExpressionTree model) {
+          s[i] += fmt.Format(model);
+        } else { s[i] += ModelSet[i - 1].ToString(); }
+      }
+      return s;
+    }
+    public void MapFromFileRead(string fileName) {
+      string input = File.ReadAllText(fileName);
+      int i = 0;
+      foreach (var row in input.Split('\n')) {
+        Map.Add(new List<int>());
+        foreach (var col in row.Trim().Split(' ')) {
+          Map[i].Add(int.Parse(col.Trim()));
+        }
+        i++;
+      }
+    }
+    protected void MapSizeCheck() {
+      if (Map != null) Map.Clear();
+      else Map = new List<List<int>>();
+      if (Map.Count != K) {
+        if (Map.Count != 0) {
+          Map.Clear();
+        }
+        for (int i = 0; i < K; i++) {
+          Map.Add(new List<int>());
+        }
+      }
+    }
+    protected void MapPreparation() {
+      for (int i = 0; i < Map.Count; i++) {
+        for (int j = 0; j < Map[i].Count; j++) {
+          ClusterNumber.Add(0);
+        }
+      }
+      for (int i = 0; i < Map.Count; i++) {
+        for (int j = 0; j < Map[i].Count; j++) {
+          ClusterNumber[Map[i][j]] = i;
+        }
+      }
+    }
+  }
+}
